Subject: Re: [PATCH] base: soc: Export soc_device_to_device() helper

From: Lee Jones <[email-masked]>
Date: Tue, 12 Nov 2019 10:48:56 +0000

On Tue, 12 Nov 2019, Uwe Kleine-König wrote:

> On Tue, Nov 12, 2019 at 06:23:47AM +0100, Greg Kroah-Hartman wrote:
> > On Mon, Nov 11, 2019 at 09:10:41PM +0100, Andreas Färber wrote:
> > > Am 11.11.19 um 07:40 schrieb Greg Kroah-Hartman:
> > > > On Mon, Nov 11, 2019 at 06:42:05AM +0100, Andreas Färber wrote:
> > > >> Hi Greg,
> > > >>
> > > >> Am 11.11.19 um 06:27 schrieb Greg Kroah-Hartman:
> > > >>> On Mon, Nov 11, 2019 at 05:56:09AM +0100, Andreas Färber wrote:
> > > >>>> Use of soc_device_to_device() in driver modules causes a build failure.
> > > >>>> Given that the helper is nicely documented in include/linux/sys_soc.h,
> > > >>>> let's export it as GPL symbol.
> > > >>>
> > > >>> I thought we were fixing the soc drivers to not need this.  What
> > > >>> happened to that effort?  I thought I had patches in my tree (or
> > > >>> someone's tree) that did some of this work already, such that this
> > > >>> symbol isn't needed anymore.
> > > >>
> > > >> I do still see this function used in next-20191108 in drivers/soc/.
> > > >>
> > > >> I'll be happy to adjust my RFC driver if someone points me to how!
> > > > 
> > > > Look at c31e73121f4c ("base: soc: Handle custom soc information sysfs
> > > > entries") for how you can just use the default attributes for the soc to
> > > > create the needed sysfs files, instead of having to do it "by hand"
> > > > which is racy and incorrect.
> > > 
> > > Unrelated.
> > > 
> > > >> Given the current struct layout, a type cast might work (but ugly).
> > > >> Or if we stay with my current RFC driver design, we could use the
> > > >> platform_device instead of the soc_device (which would clutter the
> > > >> screen more than "soc soc0:") or resort to pr_info() w/o device.
> > > > 
> > > > Ick, no, don't cast blindly.  What do you need the pointer for?  Is this
> > > > for in-tree code?
> > > 
> > > No, an RFC patchset: https://patchwork.kernel.org/cover/11224261/
> > > 
> > > As I indicated above, I used it for a dev_info(), which I can easily
> > > avoid by using pr_info() instead:
> > > 
> > > diff --git a/drivers/soc/realtek/chip.c b/drivers/soc/realtek/chip.c
> > > index e5078c6731fd..f9380e831659 100644
> > > --- a/drivers/soc/realtek/chip.c
> > > +++ b/drivers/soc/realtek/chip.c
> > > @@ -178,8 +178,7 @@ static int rtd_soc_probe(struct platform_device *pdev)
> > > 
> > >         platform_set_drvdata(pdev, soc_dev);
> > > 
> > > -       dev_info(soc_device_to_device(soc_dev),
> > > -               "%s %s (0x%08x) rev %s (0x%08x) detected\n",
> > > +       pr_info("%s %s (0x%08x) rev %s (0x%08x) detected\n",
> > >                 soc_dev_attr->family, soc_dev_attr->soc_id, chip_id,
> > >                 soc_dev_attr->revision, chip_rev);
> > 
> > First off, the driver should not be spitting out noise for when all goes
> > well like this :)
> 
> I didn't follow the discussion closely, but I think I want to object
> here a bit. While I agree that each driver emitting some stuff to the
> log buffer is hardly helpful, seeing the exact SoC details is indeed
> useful at times. With my Debian kernel team member hat on, I'd say
> keep this information. This way the SoC details make it into kernel bug
> reports without effort on our side.

Right. From my angle we are starting to be way too aggressive with the
point about not printing information to the kernel log. In only a
small set of cases does this actually cause an issue i.e. with
platforms containing so many devices that printing information from
each of them does significantly increase boot times. In my world of
small electronics I've been greatly hindered by the lack of
information, such that it has cost days of engineering trying to track
down fictitious bugs and the like.

For platforms where printing useful information culminates in negative
effects, perhaps simply lower their log level, rather than suffocate
all platforms.

-- 
Lee Jones [李琼斯]
Linaro Services Technical Lead
Linaro.org │ Open source software for ARM SoCs
Follow Linaro: Facebook | Twitter | Blog

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel